Index: palm/trunk/TESTS/cases/urban_environment_salsa/MONITORING/urban_environment_salsa_rc
===================================================================
--- palm/trunk/TESTS/cases/urban_environment_salsa/MONITORING/urban_environment_salsa_rc	(revision 4342)
+++ palm/trunk/TESTS/cases/urban_environment_salsa/MONITORING/urban_environment_salsa_rc	(revision 4347)
@@ -1,9 +1,9 @@
 
  ******************************    --------------------------------------------
- * PALM 6.0  Rev: 4325M       *    atmosphere - run without 1D - prerun
+ * PALM 6.0  Rev: 3915M       *    atmosphere - run without 1D - prerun
  ******************************    --------------------------------------------
 
- Date:               2019-12-06    Run:       urban_environment_salsa__gfortran_
- Time:                 14:05:29    Run-No.:   00
+ Date:               2019-12-18    Run:       urban_environment_salsa__gfortran_
+ Time:                 13:56:13    Run-No.:   00
  Run on host:        gfortran_d
  Number of PEs:               2    Processor grid (x,y): (   1,   2) calculated
@@ -120,5 +120,5 @@
 
        Height:           0.0       0.0  m
-       Humidity:     0.1E-02   0.7E-02  kg/kg
+       Humidity:     0.1E-02   0.4E-02  kg/kg
        Gradient:    --------   0.0E+00  (kg/kg)/100m
        Gridpoint:          0         0
@@ -229,5 +229,5 @@
  ------------------------------
 
- Canopy mode: read_from_file_3d             
+ Canopy mode: read_from_file                
  Canopy height:  10.00m (   5 grid points)
  Leaf drag coefficient:   0.30
@@ -325,44 +325,44 @@
 RUN  ITER. HH:MM:SS.SS    DT(E)     UMAX     VMAX     WMAX     U*    W*      THETA*     Z_I     ENERG.   DISTENERG    DIVOLD     DIVNEW     UMAX(KJI)    VMAX(KJI)    WMAX(KJI)   ADVECX   ADVECY   MGCYC
 ---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
-  0      0 00:00:00.00   0.7580A  -2.3731D -1.1942D  0.4177  0.064  0.00  -0.164E+00     16.  0.137E+01  0.743E-02  0.234E-01  0.446E-02   60  17  18   19   0  14   20  18   0    0.000    0.000       0
-  0      1 00:00:00.75   0.7580A  -2.3732  -1.5382   0.7410  0.085  0.33  -0.816E+00      2.  0.137E+01  0.116E-01  0.268E-02  0.892E-03   60  18  15   16  15   0   20  18   0    0.000    0.000       0
-  0      2 00:00:01.51   0.7580A  -2.3733  -1.6029   0.8137  0.083  0.00  -0.827E+00      2.  0.137E+01  0.125E-01  0.953E-03  0.351E-03   60  17  14   16  15   0   20  17   0    0.000    0.000       0
-  0      3 00:00:02.27   0.7580A  -2.3733  -1.5856   0.8391  0.083  0.00  -0.842E+00      2.  0.137E+01  0.129E-01  0.818E-03  0.240E-03   60  17  13   17  15   0   20  17   0    0.000    0.000       0
-  0      4 00:00:03.03   0.7580A  -2.3734  -1.5378   0.8462  0.082  0.13  -0.845E+00     12.  0.137E+01  0.132E-01  0.778E-03  0.213E-03   60  17  13   17  15   0   20  17   0    0.000    0.000       0
-  0      5 00:00:03.79   0.7580A  -2.3735  -1.5013   0.8440  0.081  0.17  -0.848E+00     12.  0.137E+01  0.134E-01  0.769E-03  0.205E-03   60  17  12   17  14   0   20  17   0    0.000    0.000       0
-  0      6 00:00:04.54   0.7580A  -2.3736  -1.4550   0.8381  0.081  0.18  -0.849E+00     12.  0.137E+01  0.137E-01  0.763E-03  0.201E-03   60  17  11   17  14   0   20  17   0    0.000    0.000       0
-  0      7 00:00:05.30   0.7580A  -2.3736  -1.4340   0.8310  0.080  0.24  -0.849E+00     18.  0.137E+01  0.140E-01  0.760E-03  0.199E-03   60  16  10   11  14   0   20  17   0    0.000    0.000       0
-  0      8 00:00:06.06   0.7580A  -2.3737  -1.4045   0.8235  0.080  0.24  -0.849E+00     18.  0.137E+01  0.143E-01  0.759E-03  0.197E-03   60  16  10   11  14   0   20  17   0    0.000    0.000       0
-  0      9 00:00:06.82   0.7580A  -2.3738  -1.3772   0.8160  0.079  0.25  -0.849E+00     18.  0.137E+01  0.146E-01  0.759E-03  0.196E-03   60  16   9   11  14   0   20  17   0    0.000    0.000       0
-  0     10 00:00:07.58   0.7580A  -2.3739  -1.3551   0.8089  0.078  0.25  -0.849E+00     18.  0.137E+01  0.149E-01  0.760E-03  0.196E-03   60  15   8   11  14   0   20  17   0    0.000    0.000       0
-  0     11 00:00:08.33   0.7580A  -2.3739  -1.3370   0.8028  0.078  0.25  -0.849E+00     18.  0.137E+01  0.153E-01  0.763E-03  0.196E-03   60  15   7   11  14   0   20  17   0    0.000    0.000       0
-  0     12 00:00:09.09   0.7580A  -2.3740  -1.3233   0.7983  0.077  0.26  -0.849E+00     18.  0.136E+01  0.156E-01  0.767E-03  0.195E-03   60  15   6   16  14   0   20  17   0    0.000    0.000       0
-  0     13 00:00:09.85   0.7580A  -2.3741  -1.3182   0.7955  0.077  0.26  -0.849E+00     18.  0.136E+01  0.160E-01  0.772E-03  0.195E-03   60  14   6   16  14   0   20  17   0    0.000    0.000       0
-  0     14 00:00:10.61   0.7580A  -2.3742  -1.3097   0.7942  0.076  0.26  -0.850E+00     18.  0.136E+01  0.164E-01  0.777E-03  0.195E-03   60  14   5   16  14   0   20  17   0    0.000    0.000       0
-  0     15 00:00:11.37   0.7580A  -2.3743  -1.2976   0.7935  0.076  0.26  -0.850E+00     18.  0.136E+01  0.168E-01  0.781E-03  0.194E-03   60  13   4   16  14   0   20  17   0    0.000    0.000       0
-  0     16 00:00:12.12   0.7580A  -2.3743  -1.2822   0.8042  0.076  0.27  -0.849E+00     18.  0.136E+01  0.172E-01  0.783E-03  0.193E-03   60  13   3   16  14   0   11  14  18    0.000    0.000       0
-  0     17 00:00:12.88   0.7580A  -2.3744  -1.2633   0.8295  0.075  0.27  -0.848E+00     18.  0.136E+01  0.176E-01  0.786E-03  0.192E-03   60  12   2   16  14   0   11  14  18    0.000    0.000       0
-  0     18 00:00:13.64   0.7580A  -2.3745  -1.2574   0.8603  0.075  0.27  -0.847E+00     18.  0.136E+01  0.180E-01  0.790E-03  0.191E-03   60  12   1   11  14   0   10  14  18    0.000    0.000       0
-  0     19 00:00:14.40   0.7580A  -2.3746  -1.2531   0.8934  0.075  0.27  -0.846E+00     18.  0.136E+01  0.184E-01  0.793E-03  0.190E-03   60  12   1   11  14   0   10  14  18    0.000    0.000       0
-  0     20 00:00:15.16   0.7580A  -2.3746  -1.2498   0.9249  0.074  0.28  -0.846E+00     18.  0.136E+01  0.188E-01  0.796E-03  0.188E-03   60  12   0   11  14   0   10  14  18    0.000    0.000       0
-  0     21 00:00:15.91   0.7580A  -2.3747  -1.2472   0.9528  0.074  0.28  -0.846E+00     18.  0.136E+01  0.192E-01  0.800E-03  0.187E-03   60  11  19   11  14   0   10  14  18    0.000    0.000       0
-  0     22 00:00:16.67   0.7580A  -2.3748  -1.2453   0.9759  0.074  0.40  -0.845E+00     40.  0.136E+01  0.196E-01  0.803E-03  0.185E-03   60  11  18   11  14   0   10  14  18    0.000    0.000       0
-  0     23 00:00:17.43   0.7580A  -2.3749  -1.2439   0.9933  0.073  0.40  -0.845E+00     40.  0.136E+01  0.200E-01  0.806E-03  0.184E-03   60  10  17   11  14   0   10  14  18    0.000    0.000       0
-  0     24 00:00:18.19   0.7580A  -2.3749  -1.2430   1.0052  0.073  0.40  -0.844E+00     40.  0.136E+01  0.205E-01  0.808E-03  0.182E-03   60  10  16   11  14   0   10  14  18    0.000    0.000       0
-  0     25 00:00:18.95   0.7580A  -2.3750  -1.2425   1.0120  0.073  0.41  -0.844E+00     40.  0.136E+01  0.209E-01  0.812E-03  0.181E-03   60  10  16   11  14   0   10  14  18    0.000    0.000       0
-  0     26 00:00:19.70   0.7580A  -2.3751  -1.2422   1.0160  0.072  0.41  -0.844E+00     40.  0.136E+01  0.213E-01  0.816E-03  0.180E-03   60  10  15   11  14   0   11  14  18    0.000    0.000       0
-  0     27 00:00:20.46   0.7580A  -2.3752  -1.2419   1.0277  0.072  0.41  -0.843E+00     40.  0.136E+01  0.217E-01  0.820E-03  0.178E-03   60   9  14   11  14   0   11  14  18    0.000    0.000       0
-  0     28 00:00:21.22   0.7580A  -2.3752  -1.2417   1.0341  0.072  0.41  -0.843E+00     40.  0.136E+01  0.222E-01  0.823E-03  0.177E-03   60   9  13   11  14   0   11  14  18    0.000    0.000       0
-  0     29 00:00:21.98   0.7580A  -2.3753  -1.2416   1.0351  0.072  0.42  -0.843E+00     40.  0.136E+01  0.226E-01  0.827E-03  0.176E-03   60   9  12   11  14   0   11  14  18    0.000    0.000       0
-  0     30 00:00:22.74   0.7580A  -2.3754  -1.2415   1.0316  0.071  0.42  -0.843E+00     40.  0.136E+01  0.230E-01  0.831E-03  0.175E-03   60   8  11   11  14   0   11  14  18    0.000    0.000       0
-  0     31 00:00:23.49   0.7580A  -2.3755  -1.2415   1.0243  0.071  0.42  -0.843E+00     40.  0.136E+01  0.235E-01  0.835E-03  0.175E-03   60   8  10   11  14   0   11  14  18    0.000    0.000       0
-  0     32 00:00:24.25   0.7580A  -2.3755  -1.2416   1.0147  0.071  0.43  -0.843E+00     40.  0.136E+01  0.239E-01  0.839E-03  0.174E-03   60   8  10   11  14   0   11  14  18    0.000    0.000       0
-  0     33 00:00:25.01   0.7580A  -2.3756  -1.2416   1.0041  0.071  0.43  -0.843E+00     40.  0.136E+01  0.243E-01  0.844E-03  0.173E-03   60   7   9   11  14   0   11  14  18    0.000    0.000       0
-  0     34 00:00:25.77   0.7580A  -2.3757  -1.2414   0.9940  0.070  0.43  -0.843E+00     40.  0.136E+01  0.247E-01  0.848E-03  0.172E-03   60   7   8   11  14   0   10  14  18    0.000    0.000       0
-  0     35 00:00:26.53   0.7580A  -2.3758  -1.2407   1.0100  0.070  0.44  -0.843E+00     40.  0.136E+01  0.252E-01  0.852E-03  0.172E-03   60   7   7   11  14   0   11  14  17    0.000    0.000       0
-  0     36 00:00:27.28   0.7580A  -2.3759  -1.2393   1.0277  0.070  0.44  -0.843E+00     40.  0.136E+01  0.256E-01  0.856E-03  0.171E-03   60   6   6   11  14   0   11  14  17    0.000    0.000       0
-  0     37 00:00:28.04   0.7580A  -2.3759  -1.2369   1.0437  0.070  0.44  -0.844E+00     40.  0.136E+01  0.261E-01  0.859E-03  0.170E-03   60   6   5   11  14   0   11  14  17    0.000    0.000       0
-  0     38 00:00:28.80   0.7580A  -2.3760  -1.2334   1.0564  0.070  0.45  -0.844E+00     40.  0.136E+01  0.265E-01  0.862E-03  0.170E-03   60   6   5   11  14   0   11  14  17    0.000    0.000       0
-  0     39 00:00:29.56   0.7580A  -2.3761  -1.2286   1.0644  0.070  0.45  -0.844E+00     40.  0.136E+01  0.269E-01  0.866E-03  0.169E-03   60   5   3   11  14   0   11  14  17    0.000    0.000       0
-  0     40 00:00:30.32   0.7580A  -2.3762  -1.2225   1.0674  0.069  0.45  -0.844E+00     40.  0.136E+01  0.274E-01  0.870E-03  0.169E-03   60   5   3   11  14   0   11  14  17    0.000    0.000       0
-  0     41 00:00:31.07   0.7580A  -2.3762  -1.2213   1.0651  0.069  0.45  -0.844E+00     40.  0.136E+01  0.278E-01  0.874E-03  0.168E-03   60   5   2   11  13   0   11  14  17    0.000    0.000       0
+  0      0 00:00:00.00   0.7580A  -2.3731D -1.1942D  0.4177  0.062  0.00  -0.154E+00     16.  0.137E+01  0.743E-02  0.234E-01  0.446E-02   60  17  18   19   0  14   20  18   0    0.000    0.000       0
+  0      1 00:00:00.75   0.7580A  -2.3732  -1.5382   0.7410  0.084  0.33  -0.798E+00      2.  0.137E+01  0.116E-01  0.268E-02  0.892E-03   60  18  15   16  15   0   20  18   0    0.000    0.000       0
+  0      2 00:00:01.51   0.7580A  -2.3733  -1.6029   0.8137  0.083  0.00  -0.809E+00      2.  0.137E+01  0.125E-01  0.953E-03  0.351E-03   60  17  14   16  15   0   20  17   0    0.000    0.000       0
+  0      3 00:00:02.27   0.7580A  -2.3733  -1.5856   0.8391  0.083  0.00  -0.824E+00      2.  0.137E+01  0.129E-01  0.818E-03  0.240E-03   60  17  13   17  15   0   20  17   0    0.000    0.000       0
+  0      4 00:00:03.03   0.7580A  -2.3734  -1.5378   0.8462  0.082  0.13  -0.827E+00     12.  0.137E+01  0.132E-01  0.778E-03  0.213E-03   60  17  13   17  15   0   20  17   0    0.000    0.000       0
+  0      5 00:00:03.79   0.7580A  -2.3735  -1.5014   0.8440  0.081  0.17  -0.830E+00     12.  0.137E+01  0.134E-01  0.769E-03  0.205E-03   60  17  12   17  14   0   20  17   0    0.000    0.000       0
+  0      6 00:00:04.54   0.7580A  -2.3736  -1.4550   0.8381  0.081  0.18  -0.831E+00     12.  0.137E+01  0.137E-01  0.763E-03  0.201E-03   60  17  11   17  14   0   20  17   0    0.000    0.000       0
+  0      7 00:00:05.30   0.7580A  -2.3736  -1.4340   0.8309  0.080  0.24  -0.832E+00     18.  0.137E+01  0.140E-01  0.759E-03  0.199E-03   60  16  10   11  14   0   20  17   0    0.000    0.000       0
+  0      8 00:00:06.06   0.7580A  -2.3737  -1.4045   0.8234  0.079  0.24  -0.831E+00     18.  0.137E+01  0.143E-01  0.759E-03  0.197E-03   60  16  10   11  14   0   20  17   0    0.000    0.000       0
+  0      9 00:00:06.82   0.7580A  -2.3738  -1.3772   0.8158  0.079  0.25  -0.831E+00     18.  0.137E+01  0.146E-01  0.759E-03  0.196E-03   60  16   9   11  14   0   20  17   0    0.000    0.000       0
+  0     10 00:00:07.58   0.7580A  -2.3739  -1.3551   0.8087  0.078  0.25  -0.831E+00     18.  0.137E+01  0.149E-01  0.760E-03  0.196E-03   60  15   8   11  14   0   20  17   0    0.000    0.000       0
+  0     11 00:00:08.33   0.7580A  -2.3739  -1.3370   0.8025  0.078  0.25  -0.831E+00     18.  0.137E+01  0.153E-01  0.762E-03  0.196E-03   60  15   7   11  14   0   20  17   0    0.000    0.000       0
+  0     12 00:00:09.09   0.7580A  -2.3740  -1.3232   0.7980  0.077  0.25  -0.831E+00     18.  0.136E+01  0.156E-01  0.767E-03  0.195E-03   60  14   6   16  14   0   20  17   0    0.000    0.000       0
+  0     13 00:00:09.85   0.7580A  -2.3741  -1.3182   0.7951  0.077  0.26  -0.832E+00     18.  0.136E+01  0.160E-01  0.771E-03  0.195E-03   60  14   6   16  14   0   20  17   0    0.000    0.000       0
+  0     14 00:00:10.61   0.7580A  -2.3742  -1.3096   0.7938  0.076  0.26  -0.832E+00     18.  0.136E+01  0.164E-01  0.776E-03  0.195E-03   60  14   5   16  14   0   20  17   0    0.000    0.000       0
+  0     15 00:00:11.37   0.7580A  -2.3743  -1.2976   0.7930  0.076  0.26  -0.832E+00     18.  0.136E+01  0.168E-01  0.780E-03  0.194E-03   60  13   4   16  14   0   20  17   0    0.000    0.000       0
+  0     16 00:00:12.12   0.7580A  -2.3743  -1.2822   0.8054  0.076  0.27  -0.831E+00     18.  0.136E+01  0.172E-01  0.783E-03  0.193E-03   60  13   3   16  14   0   11  14  18    0.000    0.000       0
+  0     17 00:00:12.88   0.7580A  -2.3744  -1.2633   0.8306  0.075  0.27  -0.830E+00     18.  0.136E+01  0.176E-01  0.785E-03  0.192E-03   60  12   2   16  14   0   11  14  18    0.000    0.000       0
+  0     18 00:00:13.64   0.7580A  -2.3745  -1.2576   0.8615  0.075  0.27  -0.829E+00     18.  0.136E+01  0.180E-01  0.789E-03  0.191E-03   60  12   1   11  14   0   10  14  18    0.000    0.000       0
+  0     19 00:00:14.40   0.7580A  -2.3746  -1.2533   0.8947  0.074  0.27  -0.829E+00     18.  0.136E+01  0.184E-01  0.792E-03  0.190E-03   60  12   1   11  14   0   10  14  18    0.000    0.000       0
+  0     20 00:00:15.16   0.7580A  -2.3746  -1.2500   0.9263  0.074  0.28  -0.828E+00     18.  0.136E+01  0.188E-01  0.795E-03  0.188E-03   60  12   0   11  14   0   10  14  18    0.000    0.000       0
+  0     21 00:00:15.91   0.7580A  -2.3747  -1.2475   0.9542  0.074  0.28  -0.828E+00     18.  0.136E+01  0.192E-01  0.799E-03  0.187E-03   60  11  19   11  14   0   10  14  18    0.000    0.000       0
+  0     22 00:00:16.67   0.7580A  -2.3748  -1.2456   0.9773  0.073  0.40  -0.828E+00     40.  0.136E+01  0.196E-01  0.802E-03  0.185E-03   60  11  18   11  14   0   10  14  18    0.000    0.000       0
+  0     23 00:00:17.43   0.7580A  -2.3749  -1.2442   0.9948  0.073  0.40  -0.827E+00     40.  0.136E+01  0.200E-01  0.805E-03  0.184E-03   60  10  17   11  14   0   10  14  18    0.000    0.000       0
+  0     24 00:00:18.19   0.7580A  -2.3749  -1.2433   1.0066  0.073  0.40  -0.827E+00     40.  0.136E+01  0.205E-01  0.808E-03  0.182E-03   60  10  16   11  14   0   10  14  18    0.000    0.000       0
+  0     25 00:00:18.95   0.7580A  -2.3750  -1.2428   1.0134  0.073  0.41  -0.826E+00     40.  0.136E+01  0.209E-01  0.811E-03  0.181E-03   60  10  16   11  14   0   10  14  18    0.000    0.000       0
+  0     26 00:00:19.70   0.7580A  -2.3751  -1.2425   1.0179  0.072  0.41  -0.826E+00     40.  0.136E+01  0.213E-01  0.815E-03  0.179E-03   60  10  15   11  14   0   11  14  18    0.000    0.000       0
+  0     27 00:00:20.46   0.7580A  -2.3752  -1.2423   1.0297  0.072  0.41  -0.826E+00     40.  0.136E+01  0.217E-01  0.819E-03  0.178E-03   60   9  14   11  14   0   11  14  18    0.000    0.000       0
+  0     28 00:00:21.22   0.7580A  -2.3752  -1.2421   1.0360  0.072  0.41  -0.825E+00     40.  0.136E+01  0.222E-01  0.822E-03  0.177E-03   60   9  13   11  14   0   11  14  18    0.000    0.000       0
+  0     29 00:00:21.98   0.7580A  -2.3753  -1.2420   1.0371  0.072  0.42  -0.825E+00     40.  0.136E+01  0.226E-01  0.826E-03  0.176E-03   60   9  12   11  14   0   11  14  18    0.000    0.000       0
+  0     30 00:00:22.74   0.7580A  -2.3754  -1.2419   1.0335  0.071  0.42  -0.825E+00     40.  0.136E+01  0.230E-01  0.830E-03  0.175E-03   60   8  11   11  14   0   11  14  18    0.000    0.000       0
+  0     31 00:00:23.49   0.7580A  -2.3755  -1.2419   1.0262  0.071  0.42  -0.825E+00     40.  0.136E+01  0.234E-01  0.834E-03  0.175E-03   60   8  10   11  14   0   11  14  18    0.000    0.000       0
+  0     32 00:00:24.25   0.7580A  -2.3755  -1.2420   1.0166  0.071  0.43  -0.825E+00     40.  0.136E+01  0.239E-01  0.838E-03  0.174E-03   60   8  10   11  14   0   11  14  18    0.000    0.000       0
+  0     33 00:00:25.01   0.7580A  -2.3756  -1.2419   1.0060  0.071  0.43  -0.825E+00     40.  0.136E+01  0.243E-01  0.843E-03  0.173E-03   60   7   9   11  14   0   11  14  18    0.000    0.000       0
+  0     34 00:00:25.77   0.7580A  -2.3757  -1.2416   0.9956  0.070  0.43  -0.825E+00     40.  0.136E+01  0.247E-01  0.847E-03  0.172E-03   60   7   8   11  14   0   10  14  18    0.000    0.000       0
+  0     35 00:00:26.53   0.7580A  -2.3758  -1.2407   1.0133  0.070  0.44  -0.825E+00     40.  0.136E+01  0.252E-01  0.851E-03  0.171E-03   60   7   7   11  14   0   11  14  17    0.000    0.000       0
+  0     36 00:00:27.28   0.7580A  -2.3758  -1.2392   1.0313  0.070  0.44  -0.826E+00     40.  0.136E+01  0.256E-01  0.854E-03  0.171E-03   60   6   6   11  14   0   11  14  17    0.000    0.000       0
+  0     37 00:00:28.04   0.7580A  -2.3759  -1.2367   1.0474  0.070  0.44  -0.826E+00     40.  0.136E+01  0.260E-01  0.858E-03  0.170E-03   60   6   5   11  14   0   11  14  17    0.000    0.000       0
+  0     38 00:00:28.80   0.7580A  -2.3760  -1.2330   1.0601  0.070  0.44  -0.826E+00     40.  0.136E+01  0.265E-01  0.861E-03  0.170E-03   60   6   5   11  14   0   11  14  17    0.000    0.000       0
+  0     39 00:00:29.56   0.7580A  -2.3761  -1.2280   1.0680  0.069  0.45  -0.826E+00     40.  0.136E+01  0.269E-01  0.865E-03  0.169E-03   60   5   3   11  14   0   11  14  17    0.000    0.000       0
+  0     40 00:00:30.32   0.7580A  -2.3762  -1.2216   1.0706  0.069  0.45  -0.826E+00     40.  0.136E+01  0.273E-01  0.869E-03  0.168E-03   60   5   3   11  14   0   11  14  17    0.000    0.000       0
+  0     41 00:00:31.07   0.7580A  -2.3762  -1.2215   1.0679  0.069  0.45  -0.826E+00     40.  0.136E+01  0.278E-01  0.873E-03  0.168E-03   60   5   2   11  13   0   11  14  17    0.000    0.000       0